//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "CpkKeyWins2.h"
#include "CpkKeyImpDlgs.h"
#include "Cyberpunk.h"
#include "Mixmaster.h"
#include "WipeDlgs.h"
#include "HelpDlgs.h"
#include "FileMan.h"
#include "FileWin.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma link "KeyringWins"
#pragma resource "*.dfm"
TStringList *cpkshorts;
TCpkKeyWin2 *CpkKeyWin2=NULL;
//---------------------------------------------------------------------------
// TCpkKey
//---------------------------------------------------------------------------
__fastcall TCpkKey2::TCpkKey2()
  : TCustomKey()
{
}
//---------------------------------------------------------------------------
__fastcall TCpkKey2::TCpkKey2(TCustomKey *key)
  : TCustomKey()
{
   if (!key || !key->Count) return;
   //TPGPkey *KEY = ((TCpkKey2*)key)->pgpkey;
   AddObject(key->Strings[0],key);
   fEnabled = key->enabled;
}
//---------------------------------------------------------------------------
__fastcall TCpkKey2::TCpkKey2(TStrings *key, bool Enabled)
  : TCustomKey()
{
   TPGPkey *KEY = new TPGPkey(key);
   AnsiString keyline = GetEAddress(KEY->firstuid)+","+KEY->idtext8+","+KEY->algostr;
   KEY->enable(Enabled);
   fEnabled = Enabled;
   AddObject(keyline,KEY);
}
//---------------------------------------------------------------------------
__fastcall TCpkKey2::TCpkKey2(TPGPkey *key)
  : TCustomKey()
{
   TPGPkey *KEY = new TPGPkey(key);
   AnsiString keydesc = GetEAddress(KEY->firstuid)+","+KEY->idtext8+","+KEY->algostr;
   fEnabled = KEY->enabled;
   AddObject(keydesc,KEY);
}
//---------------------------------------------------------------------------
__fastcall TCpkKey2::~TCpkKey2()
{
   delete pgpkey;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCpkKey2::Algo()
{
   return pgpkey->algostr;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKey2::SetEnabled(bool Enabled)
{
   pgpkey->cpkenable(Enabled);
   fEnabled = Enabled;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCpkKey2::Address()
{
   return GetEAddress(pgpkey->firstuid);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCpkKey2::Name()
{
   AnsiString name = cpkshorts->Values[Address()];
   if (name.IsEmpty()) name = "nameless";
   return name;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCpkKey2::KeyId()
{
   return pgpkey->idtext8;
}
//---------------------------------------------------------------------------
TPGPkey*__fastcall TCpkKey2::PgpKey()
{
   TPGPkey *key = (TPGPkey*)Objects[0];
   key->rewind();
   return key;
}
//---------------------------------------------------------------------------
// TCpkKeyList
//---------------------------------------------------------------------------
__fastcall TCpkKeyList2::TCpkKeyList2()
   : TCustomKeyList()
{
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList2::TCpkKeyList2(AnsiString filename)
   : TCustomKeyList()
{
   LoadFromFile(filename);
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList2::TCpkKeyList2(TCustomKeyList *keys)
   : TCustomKeyList()
{
   AddKeys(keys);
   modified = false;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList2::TCpkKeyList2(TCustomKey *key)
   : TCustomKeyList(key)
{
   TCpkKey2 *KEY = new TCpkKey2(key);
   if (!KEY->name.IsEmpty()) AddKey(KEY);
   delete KEY;
   modified = false;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList2::TCpkKeyList2(TStrings *Keys)
   : TCustomKeyList(Keys)
{
   AddKeys(Keys);
   modified = false;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList2::~TCpkKeyList2()
{
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyList2::LoadFromFile(AnsiString filename)
{
   Clear();
   AnsiString keyline,addr,shrt;
   TPGPkey *key = new TPGPkey();
   TPGPbuffer *keys = new TPGPbuffer(filename);
   while (key->copykeyfrom(keys))
   {
      TCpkKey2 *KEY = new TCpkKey2(key);
      AddKey(KEY);
      key->Clear();
   }
   modified = false;
   delete keys;
   delete key;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyList2::SaveToFileBak(AnsiString &docname, int bakcopies)
{
   TPGPbuffer *keys = new TPGPbuffer();
   for (int i=0; i<Count; i++)
      keys->copykeyfrom(PgpKey(i));
   TStringList *KEYS = new TStringList(); keys->exporttrust(KEYS);
 ::SaveToFileBak(KEYS,docname,bakcopies);
   modified = false;
   delete KEYS;
   delete keys;
}
//---------------------------------------------------------------------------
TCpkKey2* __fastcall TCpkKeyList2::Key(int atPos)
{
   if (atPos<0 || atPos>=Count) return NULL;
   return (TCpkKey2*)Objects[atPos];
}
//---------------------------------------------------------------------------
TPGPkey* __fastcall TCpkKeyList2::PgpKey(int atPos)
{
   if (atPos<0 || atPos>=Count) return NULL;
   return Key(atPos)->pgpkey;
}
//---------------------------------------------------------------------------
int __fastcall TCpkKeyList2::AddKeys(TCustomKeyList *keys)
{
   int c=0;
   AnsiString desc;
   for (int i=0; i<keys->Count; i++)
   {
      AddKey((TCpkKey2*)keys->Key(i));
      c++;
   }
   return c;
}
//---------------------------------------------------------------------------
int __fastcall TCpkKeyList2::AddKeys(TStrings *keys)
{
   int c=0;
   AnsiString desc;
   TPGPkey *key = new TPGPkey();
   TPGPbuffer *KEYS = new TPGPbuffer(keys);
   while (key->copykeyfrom(KEYS))
   {
      AddKey(key); key->clear();
      c++;
   }
   delete KEYS;
   delete key;
   return c;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyList2::LoadFromStrings(TStrings *keys)
{
   Clear(); AddKeys(keys);
   modified = false;
}
//---------------------------------------------------------------------------
bool __fastcall TCpkKeyList2::AddKey(TStrings *key)
{
   if (!CpkKeyDefinately(key)) return false;
   TCpkKey2 *KEY = new TCpkKey2(key);
   AddKey(KEY);
   delete KEY;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TCpkKeyList2::AddKey(TCustomKey *key)
{
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TCpkKeyList2::AddKey(TCpkKey2 *key)
{
   if (!key || !key->Count) return false;

   TCpkKey2 *KEY = new TCpkKey2(key->pgpkey);
   AnsiString shrt=KEY->name,addr=KEY->address;
   if (shrt.Length()>shrtLen) shrtLen = shrt.Length();
   if (addr.Length()>addrLen) addrLen = addr.Length();
   AddObject(shrt+","+KEY->Strings[0],KEY);
   modified = true;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TCpkKeyList2::AddKey(TPGPkey *key)
{
   if (!key) return false;

   TCpkKey2 *KEY = new TCpkKey2(key);
   AnsiString shrt=KEY->name,addr=KEY->address;
   if (shrt.Length()>shrtLen) shrtLen = shrt.Length();
   if (addr.Length()>addrLen) addrLen = addr.Length();
   AddObject(shrt+","+KEY->Strings[0],KEY);
   modified = true;
   return true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCpkKeyList2::KeyDescription(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";

   //addrLen = 31;
   AnsiString desc,addr;
   TStringList *flds = new TStringList();
   flds->CommaText = Strings[atPos];

   addr = PadRight(flds->Strings[1],addrLen);
   desc = PadRight(flds->Strings[0],shrtLen)+"  "+addr+"  0x"+flds->Strings[2]+"  "+
      flds->Strings[3];
   delete flds;
   return desc;
}
//---------------------------------------------------------------------------
// TCpkKeyWin
//---------------------------------------------------------------------------
__fastcall TCpkKeyWin2::TCpkKeyWin2(TComponent* Owner)
	: TCustomKeyWin(Owner)
{
   keyringname = "Cypherpunk";
   hidedisabled = GetAppIni(CpkHideDisabled,"0")=="1";
   HideDisBtn->Bitmap->Assign(hidedisabled?bmpHideDis:bmpShowAll);
   keys = new TCpkKeyList2();
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyWin2::TCpkKeyWin2(TComponent* Owner, TCpkKeyList2 *Imports)
	: TCustomKeyWin(Owner)
{
   imports = Imports;
   keyringname = "Cypherpunk";
   hidedisabled = GetAppIni(CpkHideDisabled,"0")=="1";
   HideDisBtn->Bitmap->Assign(hidedisabled?bmpHideDis:bmpShowAll);
   keys = new TCpkKeyList2();
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyWin2::~TCpkKeyWin2()
{
   CpkKeyWin2 = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin2::SaveKeys()
{
   if (!keys->Count)
   {
      if (FileExists(cringtxt)) zapfile(cringtxt,1);
      return;
   }
   AnsiString cap = Caption;
   Caption = "Saving..."; AppProcessMessages(); Sleep(200);
   SaveBtn->Enabled = RefreshBtn->Enabled = false;
   keys->SaveToFileBak(cringtxt,STATSBAKCOPIES);
   newkeys->Clear();
   SetRedraw(TreeView,0);
   LoadTreeViewQuiet();
   AppProcessMessages();
   SetRedraw(TreeView,1);
   Caption = cap;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin2::EnableKey(int atPos, bool enable)
{
   if (atPos<0 || atPos>=keynodes->Count) return;

   TTreeNode* node = (TTreeNode*)keynodes->Items[atPos];
  ((TCpkKey2*)node->Data)->enabled = enable;
   if (enable)
   {
      node->ImageIndex = 2; node->SelectedIndex = 2;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }
   else
   {
      node->ImageIndex = 3; node->SelectedIndex = 3;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }
   RECT r = { 0,0,50,2000 };
   InvalidateRect(TreeView->Handle,&r,false);
   keys->modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin2::LoadKeys()
{
   initdone = true;
   if (FileExists(cringtxt)) keys->LoadFromFile(cringtxt);
   if (imports && imports->Count) AddKeysImport(imports);
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin2::LoadTreeView()
{
   TPGPkey *pgpkey;
   TCpkKey2 *cpkkey;
   TTreeNode *node,*cnode,*unode;
   keynodes->Clear();
   TreeView->Items->Clear();
   TreeView->Items->BeginUpdate();
   TStringList *next = new TStringList();
   AnsiString addr,shrt,idtext8,keydesc;
   bool isnew;

   for (int i=0; i<keys->Count; i++)
   {
      keydesc = keys->Strings[i];
      cpkkey = ((TCpkKeyList2*)keys)->Key(i);
      pgpkey = cpkkey->pgpkey;

      if (!(isnew=newkeys->Find(keydesc,NULL)) && hidedisabled &&
         (pgpkey->revoked || pgpkey->expired || !pgpkey->enabled))
            continue;

      shrt = cpkkey->name;
      addr = cpkkey->address;
      idtext8 = pgpkey->idtext8;
      node = TreeView->Items->AddChildObject(TreeView->Selected,
          keys->KeyDescription(i)+
         (pgpkey->revoked?"  <---REVOKED ":"")+
         (pgpkey->expired?"  <---EXPIRED ":""),
          cpkkey
      );
      keynodes->Add(node);

      if (isnew) SetTreeItemBold(node,true,TreeView);
      node->ImageIndex = cpkkey->enabled ? 2:3;
      node->SelectedIndex = node->ImageIndex;

      cnode=TreeView->Items->AddChild(node,"Name        "+shrt);
      cnode->ImageIndex = cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Address     "+addr);
      cnode->ImageIndex = cnode->SelectedIndex = -1;

      AnsiString keyidline = "0x"+idtext8+(pgpkey->revoked?"   <---REVOKED ":"");

      cnode=TreeView->Items->AddChild(node,"Key-Id      "+keyidline);
      cnode->ImageIndex = cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Key-Version "+s(pgpkey->version));
      cnode->ImageIndex = cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Algorithm   "+pgpkey->algostr);
      cnode->ImageIndex = cnode->SelectedIndex = -1;

      cnode=TreeView->Items->AddChild(node,"UserIds     "+pgpkey->firstuid);
      cnode->ImageIndex = cnode->SelectedIndex = -1;

      TStringList *uids = new TStringList();
      pgpkey->getuserids(uids);
      for (int i=0; i<uids->Count; i++)
      {
         unode=TreeView->Items->AddChild(cnode,uids->Strings[i]);
         unode->ImageIndex = unode->SelectedIndex = -1;
      }
      delete uids;

      cnode=TreeView->Items->AddChild(node,"TimeStamp   "+pgpkey->timestr+
         (pgpkey->revoked?"  <---REVOKED ":"")+
         (pgpkey->expired?"  <---EXPIRED ":"")
      );

      cnode->ImageIndex = cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Validity    "+s(pgpkey->validity));
      cnode->ImageIndex = cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Bits        "+pgpkey->bitsstr);
      cnode->ImageIndex = cnode->SelectedIndex = -1;
     //cnode=TreeView->Items->AddChild(node,"Enabled     "+s(cpkkey->enabled?"yes":"no"));
     //cnode->ImageIndex = cnode->SelectedIndex = -1;
   }
   TreeView->Items->EndUpdate();
   RECT r = { 0,0,4096,4096 };
   InvalidateRect(TreeView->Handle,&r,false);
   AppProcessMessages();
   delete next;
}
//---------------------------------------------------------------------------
TCpkKey2* __fastcall TCpkKeyWin2::NodeKey(int atPos)
{
   if (atPos<0 || atPos>=keynodes->Count) return NULL;
   TCpkKey2 *key = (TCpkKey2*)((TTreeNode*)keynodes->Items[atPos])->Data;
   return key;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin2::AddKeysImport(TCustomKeyList *NewKeys)
{
   while (!initdone) AppProcessMessages(); // may not be init yet
   newkeys->Text = NewKeys->Text;
   ClearTree(); Sleep(100);
   keys->AddKeys((TCpkKeyList2*)NewKeys);
   LoadTreeView();
   ClearAllBtn->Enabled = keys->Count>0 ? true:false;
   SaveBtn->Enabled = RefreshBtn->Enabled = true;
   SetNothingSelected();
   AppProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin2::AddDupsImport(TCpkKeyList2 *dupkeys)
{
   AnsiString dupitx8,dupname,dupalgo;
   int D,k,dstamp,kstamp;
   TCpkKey2 *dup,*key;

   AddKeysImport(dupkeys);
   for (int d=0; d<dupkeys->Count; d++)
   {
      k = -1;
      dup = dupkeys->Key(d);
      if (!keys->Find(dupkeys->Strings[d],D)) continue; // dup not there ?? can't happen

      dupname = dup->name;
      dupalgo = dup->algo;
      dupitx8 = dup->keyid;
      for (int i=0; i<keys->Count; i++)
      {
         key = (TCpkKey2*)keys->Key(i);
         if (dupname==key->name && dupalgo==key->algo && dupitx8!=key->pgpkey->idtext8)
         {
            k = i;
            break;
         }
      }
      if (k<0) continue; // org not there ?? can't happen

      dstamp = dup->pgpkey->timestamp;
      kstamp = key->pgpkey->timestamp;
      if (dstamp>kstamp)
      {
         EnableKey(k,false);
         EnableKey(D,true);
      }
      else
      if (kstamp>dstamp)
      {
         EnableKey(k,true);
         EnableKey(D,false);
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin2::ImportBtnClick(TObject *Sender)
{
   AnsiString ImportDir,orgDir;
   TCpkKeyList2 *impkeys = new TCpkKeyList2();
   TCpkKeyList2 *dupkeys = new TCpkKeyList2();
   ImportDir = orgDir = GetAppIni(CpkImportDir,MixDir());
   if (ImportCypherpunkKeys(this,(TCpkKeyList2*)keys,impkeys,dupkeys,ImportDir))
   {
      newkeys->Clear();
      if (impkeys->Count)
      {
         Sleep(150);
         BringToFront();
         AppProcessMessages();
         AddKeysImport(impkeys);
      }
      if (dupkeys->Count)
      {
         BringToFront();
         AppProcessMessages();
         AddDupsImport(dupkeys);
      }
   }
   if (ImportDir!=orgDir)
      PutAppIni(MixImportDir,ImportDir);
   delete dupkeys;
   delete impkeys;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin2::RemailerDocItemClick(TObject *Sender)
{
   AnsiString doc; int d;
   TMenuItem *item = dynamic_cast<TMenuItem*>(Sender);
   if (item)
   {
      doc = MixDir()+item->Caption;
      while ((d=doc.Pos("&"))>0) doc.Delete(d,1);
      if (FileExists(doc)) EditTextFile(doc);
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin2::HelpBtnClick(TObject *Sender)
{
   OpenHelp(
      "CypherpunkKeys\nCypherpunkKeysImp\nCypherpunkKeysDup\nRemailerConfig",
      "Cypherpunk Key Manager",
      "Cypherpunk Keyring Manager"
   );
}
//---------------------------------------------------------------------------
