//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <assert.h>
#pragma hdrstop

#include "FileManX.h"
#include "Mixmaster.h"
//#include "QSver.h"
#include "zlib.h"
#include "view.h"

#pragma link "zlib.lib"
bool UseCompression = true;
//---------------------------------------------------------------------------
__fastcall TBUFFER::TBUFFER()
   : TMemoryStream()
{
}
//---------------------------------------------------------------------------
__fastcall TBUFFER::TBUFFER(AnsiString Filename)
   : TMemoryStream()
{
   filename = Filename;
   if (FileExists(filename)) LoadFromFile(filename);
}
//---------------------------------------------------------------------------
__fastcall TBUFFER::~TBUFFER()
{
}
//---------------------------------------------------------------------------
void __fastcall TBUFFER::rewind()
{
   Seek(0,soFromBeginning);
}
//---------------------------------------------------------------------------
void __fastcall TBUFFER::clear()
{
   SetSize(0);
}
//---------------------------------------------------------------------------
bool __fastcall TBUFFER::save()
{
   if (filename.IsEmpty()) return false;
   SaveToFile(filename);
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TBUFFER::SetPosition(long pos)
{
   Position = pos;
}
//---------------------------------------------------------------------------
long __fastcall TBUFFER::GetPosition()
{
   return Position;
}
//---------------------------------------------------------------------------
byte* __fastcall TBUFFER::GetMemory()
{
   return ((byte*)Memory);
}
//---------------------------------------------------------------------------
long __fastcall TBUFFER::GetSize()
{
   return Size;
}
//---------------------------------------------------------------------------
byte __fastcall TBUFFER::ReadByte()
{
   byte b; Read(&b,1);
   return b;
}
byte __fastcall TBUFFER::readbyte()
{
   byte b; Read(&b,1);
   return b;
}
//---------------------------------------------------------------------------
int __fastcall TBUFFER::ReadInt()
{
   int i; Read(&i,2);
   return i;
}
int __fastcall TBUFFER::readint()
{
   int i; Read(&i,2);
   return i;
}
//---------------------------------------------------------------------------
long __fastcall TBUFFER::ReadLong()
{
   long l; Read(&l,4);
   return l;
}
long __fastcall TBUFFER::readlong()
{
   long l; Read(&l,4);
   return l;
}
//---------------------------------------------------------------------------
int  __fastcall TBUFFER::WriteByte(byte b)
{
   Write(&b,1);
   return 1;
}
int  __fastcall TBUFFER::writebyte(byte b)
{
   Write(&b,1);
   return 1;
}
//---------------------------------------------------------------------------
int  __fastcall TBUFFER::WriteInt(int i)
{
   Write(&i,2);
   return 2;
}
int  __fastcall TBUFFER::writeint(int i)
{
   Write(&i,2);
   return 2;
}
//---------------------------------------------------------------------------
int __fastcall TBUFFER::WriteLong(long l)
{
   Write(&l,4);
   return 4;
}
int __fastcall TBUFFER::writelong(long l)
{
   Write(&l,4);
   return 4;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
long __fastcall GetThisFileSize(const AnsiString FileName)
{
  TSearchRec SearchRec;
  if(FindFirst(ExpandFileName(FileName),faAnyFile,SearchRec)==0) return SearchRec.Size;
  else return 0;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
bool __fastcall TDataBuf::Encrypted()
{
   return type[3]==ENCRYPTED;
}
//---------------------------------------------------------------------------
int __fastcall TDataBuf::Encrypt(const AnsiString &password)
{
   if (type[3]!=CLEARTEXT) return 0;
   int result=data_encrypt(&data,length,password.c_str(),password.Length());
   if (result==0) type[3] = ENCRYPTED;
   return result;
}
//---------------------------------------------------------------------------
int __fastcall TDataBuf::Decrypt(const AnsiString &password)
{
   if (type[3]!=ENCRYPTED) return 0;
   int result=data_decrypt(&data,length,password.c_str(),password.Length());
   if (result==0) type[3] = 0;
   return result;
}
//---------------------------------------------------------------------------
__fastcall TDataBuf::TDataBuf(const char *Data, TFLspace Length)
{
   for (int i=0; i<4; i++) type[i] = '\0';
   data = NULL; length = orglength = 0;
   if (!Data) return;
   Set(Data,Length);
}
//---------------------------------------------------------------------------
__fastcall TDataBuf::TDataBuf(const AnsiString &Data)
{
   Set(Data.c_str(),Data.Length());
}
//---------------------------------------------------------------------------
__fastcall TDataBuf::~TDataBuf()
{
   if (data) Clear();
}
//---------------------------------------------------------------------------
void __fastcall TDataBuf::Clear()
{
   for (int i=0; i<4; i++)
      type[i] = '\0';
   ClearData();
   orglength = 0;
   length = 0;
}
//---------------------------------------------------------------------------
void __fastcall TDataBuf::ClearData()
{
   if (data)
   {
      if (sensitive) memset(data,'\0',length);
      delete [] data;
   }
   data = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TDataBuf::Set(const char *Data, TFLspace Length)
// 'Set' completely reinitializes data structure
// 'SetData' below just set data and length
{
   Clear();
   data = new char[Length+1]; data[Length] = '\0';
   if (Data>=0) memcpy(data,Data,Length); else memset(data,'0',Length);
   orglength = Length;
   length = Length;
   sensitive = true;
}
//---------------------------------------------------------------------------
void __fastcall TDataBuf::SetData(const char *Data, TFLspace Length)
// see notes on 'Set', above
{
   ClearData();
   data = new char[Length+1]; data[Length] = '\0';
   if (Data) memcpy(data,Data,Length); else memset(data,'\0',Length);
   length = Length;
}
//---------------------------------------------------------------------------
void __fastcall TDataBuf::LoadFromFile(const AnsiString &Filename)
{
   if (!FileExists(Filename)) return;
   unsigned Length=GetThisFileSize(Filename);
   if (!Length) { Set(NULL,0); return; }

   ClearData();
   data = new char[Length+1]; data[Length] = '\0';
   try
   {
      TFileStream *stream = new TFileStream(Filename,fmOpenRead);
      stream->ReadBuffer(data,Length);
      delete stream;
      orglength = Length;
      length = Length;
      sensitive = true;
   }
   catch (...)
   {
      MsgBoxHwnd(NULL,
         s("QuickSilver has failed to open/read the file:\n"+Filename+"\n\n")+
         s("Continuing without!"),
         s("File System Error"),
         MB_OK|MB_TASKMODAL
      );
      Set(NULL,0);
   }
}
//---------------------------------------------------------------------------
void __fastcall TDataBuf::SaveToFile(const AnsiString &Filename)
{
   try
   {
      TFileStream *fs = new TFileStream(Filename,fmCreate);
      fs->WriteBuffer(data,length);
      delete fs;
   }
   catch (...)
   {
      MsgBoxHwnd(NULL,
         s("QuickSilver has failed to save the file:\n"+Filename+"\n\n")+
         s("Continuing without!"),
         s("File System Error"),
         MB_OK|MB_TASKMODAL
      );
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall ZipErrMsg(const int errcode)
{
   AnsiString msg;
   switch (errcode)
   {
      case Z_STREAM_ERROR  : msg = "Decompression Error: Z_STREAM_ERROR"; break;
      case Z_MEM_ERROR     : msg = "Decompression Error: Z_MEM_ERROR"; break;
      case Z_BUF_ERROR     : msg = "Decompression Error: Z_BUF_ERROR"; break;
      case Z_VERSION_ERROR : msg = "Decompression Error: Z_VERSION_ERROR"; break;
      default:
         msg = "Decompression Error: "+AnsiString(errcode);
   }
   return msg;
}
//---------------------------------------------------------------------------
bool __fastcall TDataBuf::Compressed()
{
   return type[3]==COMPRESSED;
}
//---------------------------------------------------------------------------
int __fastcall BufCompress(TMemoryStream* data)
{
   int err;
   z_stream s;

   s.zalloc = (alloc_func) 0;
   s.zfree = (free_func) 0;
   s.opaque = (voidpf) 0;
   s.next_in = NULL;

   if ((err=deflateInit2(&s,Z_DEFAULT_COMPRESSION,Z_DEFLATED,15,9,Z_DEFAULT_STRATEGY))==Z_OK)
   {
      int len = data->Size*1.2+16;
      byte *outdata = new byte[len];

      int orglength = data->Size;  // should BE length (not 0) but it sometimes isn't...
      s.avail_in = orglength;
      s.next_in = (byte*)data->Memory;
      s.next_out = outdata;
      s.avail_out = len;
      if ((err=deflate(&s, Z_FINISH))==Z_STREAM_END)
      {
         if ((err=deflateEnd(&s))==Z_OK)
         {
            data->Seek(0,soFromBeginning);
            data->Write(outdata,s.total_out);
            //SetData((char*)outdata,s.total_out);
            //type[3]=COMPRESSED;
         }
      }
      delete [] outdata;
   }
   if (err)
      MsgBoxHwnd(NULL,ZipErrMsg(err),"Inflate Error",MB_OK|MB_TASKMODAL);
   return err;
}
//---------------------------------------------------------------------------
int __fastcall TDataBuf::Compress()
{
   int err;
   z_stream s;

   s.zalloc = (alloc_func) 0;
   s.zfree = (free_func) 0;
   s.opaque = (voidpf) 0;
   s.next_in = NULL;

   if ((err=deflateInit2(&s,Z_DEFAULT_COMPRESSION,Z_DEFLATED,15,9,Z_DEFAULT_STRATEGY))==Z_OK)
   {
      int len = length*1.2+16;
      byte *outdata = new byte[len];

      orglength = length;  // should BE length (not 0) but it sometimes isn't...
      s.avail_in = length;
      s.next_in = (byte*)data;
      s.next_out = outdata;
      s.avail_out = len;
      if ((err=deflate(&s, Z_FINISH))==Z_STREAM_END)
      {
         if ((err=deflateEnd(&s))==Z_OK)
         {
            SetData((char*)outdata,s.total_out);
            type[3]=COMPRESSED;
         }
      }
      delete [] outdata;
   }
   if (err)
      MsgBoxHwnd(NULL,ZipErrMsg(err),"Inflate Error",MB_OK|MB_TASKMODAL);
   return err;
}
//---------------------------------------------------------------------------
int __fastcall TDataBuf::Decompress()
{
   int err;
   z_stream s;

   s.zalloc = (alloc_func) 0;
   s.zfree = (free_func) 0;
   s.opaque = (voidpf) 0;

   s.next_in = (byte*)data;
   s.avail_in = length;
   s.next_out = NULL;

   if ((err=inflateInit2(&s,15))==Z_OK)
   {
      int len = orglength;
      byte *outdata = new byte[len];
      s.avail_out = len;
      s.next_out = outdata;
      if ((err=inflate(&s, Z_FINISH))==Z_STREAM_END)
      {
         if ((err=inflateEnd(&s))==Z_OK)
         {
            SetData((char*)outdata,s.total_out);
            type[3]=CLEARTEXT;
         }
      }
      delete [] outdata;
   }
   if (err)
      MsgBoxHwnd(NULL,ZipErrMsg(err),"Inflate Error",MB_OK|MB_TASKMODAL);
   return err;
}
//---------------------------------------------------------------------------
bool __fastcall TDataBuf::IsEmpty()
{
   return length==0;
}
//---------------------------------------------------------------------------
bool __fastcall TDataBuf::IsIndex()
{
   return type[1]==ISINDEX;
}
//---------------------------------------------------------------------------
bool __fastcall TDataBuf::IsData()
{
   return type[1]==ISDATA;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TDataBuf::str()
{
   return data ? AnsiString(data) : AnsiString("");
}
//---------------------------------------------------------------------------
char* __fastcall TDataBuf::c_str()
{
   char *doto = "\0";
   return data ? data : doto;
}
//---------------------------------------------------------------------------
// TFreeList
//---------------------------------------------------------------------------
__fastcall TFreeList::TFreeList() : TObject()
{
   offset = new TList();
   space = new TList();
   lastOffset = 0;
   lastSpace = 0;
}
//---------------------------------------------------------------------------
__fastcall TFreeList::~TFreeList()
{
   delete offset;
   delete space;
}
//---------------------------------------------------------------------------
bool __fastcall TFreeList::AddFreeSpace(TFLoffset Offset, TFLspace Space)
{
   int i; for (i = 0; i < offset->Count; i++)
      if (Offset < getOffset(i))
         break;

   offset->Insert(i,(void*)Offset); lastOffset = Offset;
   space->Insert(i,(void*)Space);  lastSpace = Space;
   return true;
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFreeList::Allocate(TFLspace Space)
{
   for (int i = 0; i < offset->Count; i++)
   {
      if (Space <= getSpace(i))
      {
         TFLoffset ofs = getOffset(i);
         space->Items[i] = (void*)(getSpace(i)-Space);
         if (space->Items[i] == 0)
         {
            offset->Delete(i);
            space->Delete(i);
         }
         else
            offset->Items[i] = (void*)(getOffset(i)+Space);
         return ofs;
      }
   }
   return FLNIL;
}
//---------------------------------------------------------------------------
void __fastcall TFreeList::AttemptMerge(int i)
{
   if (i < offset->Count-1)
   {
      if (getOffset(i)+(TFLoffset)getSpace(i) == getOffset(i+1))
      {
         space->Items[i] = (void*)(getSpace(i)+getSpace(i+1));
         offset->Delete(i+1);
         space->Delete(i+1);
      }
   }
}
//---------------------------------------------------------------------------
bool __fastcall TFreeList::Coalesce(TFLoffset Offset, TFLspace Space)
{
   assert(Offset>0 && Space>0);
   for (int i=0; i<offset->Count; i++)
   {
      // try merging to right of existing space...
      if (Offset == getOffset(i)+(TFLoffset)getSpace(i))
      {
         space->Items[i] = (void*)(getSpace(i)+Space);
         AttemptMerge(i);
         return true;
      }
      // try merging to left...
      if (Offset+Space == getOffset(i))
      {
         offset->Items[i] = (void*)Offset; lastOffset = Offset;
         space->Items[i] = (void*)(getSpace(i)+Space); lastSpace = getSpace(i);
         return true;
      }
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TFreeList::EnterFreeSpace(TFLoffset Offset, TFLspace Space)
{
   assert(Offset>0 && Space>0);
   if (Coalesce(Offset,Space)) return true;
   return AddFreeSpace(Offset,Space);
}
//---------------------------------------------------------------------------
bool __fastcall TFreeList::LoadFromStream(TStream *f)
{
  int i,count;
  TFLspace spc;
  TFLoffset ofs;
  int spsize=SPCSIZE,ofsize=OFSSIZE,insize=sizeof(int);

  try
  {
     if (f->Read(&count,insize) != insize) return false;

     if (offset->Count) offset->Clear();
     for (i = 0; i < count; i++)
     {
        if (f->Read(&ofs,ofsize) != ofsize) return false;
        offset->Add((void*)ofs);
     }
     if (space->Count) space->Clear();
     for (i = 0; i < count; i++)
     {
        if (f->Read(&spc,spsize) != spsize) return false;
        space->Add((void*)spc);
     }
  }
  catch (...)
  {
      MsgBoxHwnd(NULL,
         s("Failed to read the database 'free space' list from disk!\n")+
         s("QS may become unstable. Closing QS and reopening may help"),
         s("File System Error"),MB_OK|MB_TASKMODAL);
      return false;
  }
  return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFreeList::SaveToStream(TStream *f)
{
   TFLspace spc;
   TFLoffset ofs;
   int i,count=offset->Count;
   int ofsize=OFSSIZE,spsize=SPCSIZE,insize=sizeof(int);

   try
   {
      if (f->Write(&count,insize) != insize) return false;
      for (i=0; i<count; i++)
      {
         ofs = getOffset(i);
         if (f->Write(&ofs,ofsize) != ofsize)
         return false;
      }
      for (i=0; i<count; i++)
      {
         spc = getSpace(i);
         if (f->Write(&spc,spsize) != spsize)
         return false;
      }
   }
   catch (...)
   {
      MsgBoxHwnd(NULL,
         "Failed to write the database 'free space' list to disk!",
         "File System Error",MB_OK|MB_TASKMODAL);
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
int __fastcall TFreeList::Count()
{
   return offset->Count;
}
//---------------------------------------------------------------------------
// TFileManager
//----------------------------------------------------------------------------
__fastcall TFileManager::TFileManager(const AnsiString &Filename) : TObject()
{
  assert(!Filename.IsEmpty());
  failedInit = false;
  delStream = true;
  try
  {
     stream = new TFileStream(Filename,
        (unsigned short)(FileExists(Filename)?fmOpenReadWrite:fmCreate));
  }
  catch (...)
  {
     MsgBoxHwnd(NULL,
        s("Failed to open database:\n"+Filename+"\n\n")+
        s("QS may fail to open, or become unstable if it does.\n")+
        s("Restarting QS may help. If problem persists, please\n")+
        s("contact technical support: "+BUGREPORTADDRESS),
        s("File System Error"),MB_OK|MB_TASKMODAL);
     status = TOOL_OPENERR;
  }
  filename = Filename;
  Init();
}
//----------------------------------------------------------------------------
__fastcall TFileManager::TFileManager(TStream *Stream) : TObject()
{
  assert(Stream!=NULL);
  delStream = false;
  stream = Stream;
  Init();
}
//---------------------------------------------------------------------------
__fastcall TFileManager::~TFileManager()
{
   delete freeList;
   if (delStream) delete stream;
}
//---------------------------------------------------------------------------
void __fastcall TFileManager::Init()
{
  block = 0;
  status = TOOL_OK;
  startOfData = FLNIL;
  endOfData = strlen(FILEHEADER)+(2*OFSSIZE);
  freeList = new TFreeList();

  try
  {
     if(!stream->Size)  // Virgin file; must initialize it.
     {
         if (WriteHeader() && WriteStartAndEnd())
            WriteFreeList();
     }
     else
     {
         if (ReadStartAndEnd())
	        ReadFreeList();
     }
     if (status != TOOL_OK)
        fileMgrErr(status);
  }
  catch(...)
  {
     MsgBoxHwnd(NULL,
        s("Failed to initialize database: "+filename+"\n\n")+
        s("QS may fail to open, or become unstable if it does.\n")+
        s("Restarting QS may help. If problem persists, please\n")+
        s("contact technical support: "+BUGREPORTADDRESS),
        s("File System Error"),MB_OK|MB_TASKMODAL);
     status = TOOL_INITERR;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFileManager::fileMgrErr(int err)
{
   String s = "Block: "+String(block)+", ";
   switch (err)
   {
      case 0: s += "No error!"; break;
      case 1: s += "Fatal write error!"; break;
      case 2: s += "Fatal read error!"; break;
      case 3: s += "Fatal seek error!"; break;
      case 4: s += "Fatal open error!"; break;
      case 5: s += "Fatal initialization error!"; break;
      case 6: s += "Fatal disk space allocation error!"; break;
      default:
         s += "Unknown FATAL error!";
   }
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::WriteHeader()
{
   block = 9;
   status = TOOL_OK;
   if (!SeekTo(0))
   {
      status = TOOL_SEEKERR;
      return false;
   }
   if (!WriteDat(&FILEHEADER,strlen(FILEHEADER)))
   {
      status = TOOL_WRITEERR;
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
inline bool __fastcall TFileManager::SeekTo(TFLoffset offset)
{
   status = TOOL_OK;
   bool ok = stream->Seek(offset,soFromBeginning)==(long)offset;
   if (!ok) status = TOOL_SEEKERR;
   return ok;
}
//---------------------------------------------------------------------------
inline bool __fastcall TFileManager::WriteDat(void *dat, long size)
{
   status = TOOL_OK;
   bool ok = stream->Write(dat,size)==size;
   if (!ok) status = TOOL_WRITEERR;
   return ok;
}
//---------------------------------------------------------------------------
inline bool __fastcall TFileManager::ReadDat(void *dat, long size)
{
   status = TOOL_OK;
   bool ok = stream->Read(dat,size)==size;
   if (!ok) status = TOOL_READERR;
   return ok;
}
//---------------------------------------------------------------------------
// Read the free list
bool __fastcall TFileManager::ReadFreeList()
{
  block = 1;
  if (!SeekTo(endOfData)) return false;

  if (!freeList->LoadFromStream(stream))
  {
     status = TOOL_READERR;
     return false;
  }
  return true;
}
//---------------------------------------------------------------------------
// Write the free list
bool __fastcall TFileManager::WriteFreeList()
{
  block = 2;
  if (!SeekTo(endOfData)) return false;

  if (!freeList->SaveToStream(stream))
  {
     status = TOOL_WRITEERR;
     return false;
  }
  return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::WriteStartAndEnd()
{
   block = 10;
   if (!SeekTo(strlen(FILEHEADER)))
      return false;

   if (!WriteDat(&startOfData,2*OFSSIZE))
      return false;

   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::ReadStartAndEnd()
{
   block = 11;
   if (!SeekTo(strlen(FILEHEADER)))
      return false;

   if (!ReadDat(&startOfData,2*OFSSIZE))
      return false;

   return true;
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFileManager::Allocate(TFLspace spaceRequested)
{
  block = 3;
  assert(spaceRequested>0);
  if (!spaceRequested) return FLNIL;

  // Space we will actually need is space requested plus header:
  TFLspace spaceRequired = spaceRequested+sizeofHeader;
  TFLoffset ret = AllocateInFreeList(spaceRequired);
  if (ret==FLNIL) ret = AllocateAtEnd(spaceRequired);

  if (status != TOOL_OK) return FLNIL;

  if(status==TOOL_OK && startOfData==FLNIL)
  {
     startOfData=ret;
     WriteStartAndEnd();
  }
  if (status==TOOL_OK)
     WriteFreeList();

  if (status != TOOL_OK)
     fileMgrErr(status);

  return ret;
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFileManager::AllocateInFreeList(TFLspace spaceRequired)
{
  block = 4;
  status = TOOL_OK;

  TFLoffset startOfAlloc = freeList->Allocate(spaceRequired);
  if (startOfAlloc == FLNIL) return FLNIL;	// Unsuccessful
  if (SeekTo(startOfAlloc) && WriteDat(&spaceRequired,SPCSIZE))
     WriteFreeList();

  return startOfAlloc+sizeofHeader;
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFileManager::AllocateAtEnd(TFLspace spaceRequired)
{
  block = 5;
  status = TOOL_OK;
  TFLoffset ret = endOfData+(TFLoffset)sizeofHeader;
  // Record the space allocated in the header:
  if (SeekTo(endOfData) && WriteDat(&spaceRequired,SPCSIZE))
  {
     // Update and record new endOfData:
     endOfData += (TFLoffset)spaceRequired;
     WriteStartAndEnd();
  }
  else
  {
     MsgBoxHwnd(NULL,
        s("Failed to allocate needed disk space for holding\n")+
        s("application data. QS may become unstable. Insufficient\n")+
        s("disk space is most likely the problem."),
        s("File System Error"),MB_OK|MB_TASKMODAL);
     status = TOOL_ALLOCERR;
     return FLNIL;
  }
  return ret;
}
//---------------------------------------------------------------------------
// Deallocate storage.
void __fastcall TFileManager::Deallocate(TFLoffset offset)
{
   assert(offset>0);
   block = 6;
   status = TOOL_OK;
   // Can't deallocate first allocated block or FLNIL:
   if ( offset == FLNIL || offset == start() ) return;

   // Start of record, including record header:
   TFLoffset startOfRecord = offset-(TFLoffset)sizeofHeader;
   TFLspace spaceFreed;

   if (SeekTo(startOfRecord) && ReadDat(&spaceFreed,SPCSIZE) &&
       AddToFreeList(startOfRecord, spaceFreed))
          WriteFreeList();
   if (status != TOOL_OK)
      fileMgrErr(status);
}
//---------------------------------------------------------------------------
// Add a free space to current free list block.
bool __fastcall TFileManager::AddToFreeList(TFLoffset offset, TFLspace space)
{
   assert(offset>0 && space>0);
   block = 7;
   status = TOOL_OK;
   if (!space) return true;

   // If last record is deleted, redefine endOfData.
   if (offset+(TFLoffset)space >= endOfData)
   {  // If last record removed
      endOfData = offset;
      if (!WriteStartAndEnd())
         return false;
   }
   else
   if (!freeList->EnterFreeSpace(offset, space))
      return false;

   return true;
}
//---------------------------------------------------------------------------
// TFMindex
//---------------------------------------------------------------------------
__fastcall TFMindex::TFMindex(TFileManager *Fm, AnsiString Name, TFMindex *Parent)
{
   fm = Fm;
   name = Name;
   parent = Parent;
   if (parent && !name.IsEmpty())
      offset = parent->GetOffset(name);
   else
   {
      // initialize first allocation if necessary
      if (fm->start() == FLNIL)
      {
         offset = FLNIL;
         fm->SeekTo(fm->Allocate(OFSSIZE));
         fm->WriteDat(&offset,OFSSIZE);
      }
      else // or just read offset
      {
         fm->SeekTo(fm->start());
         fm->ReadDat(&offset,OFSSIZE);
      }
   }
   if (offset == FLNIL) return;

   void *p;
   fm->SeekTo(offset);
   TDataBuf *buf = new TDataBuf();
   if (buf)
   {
      try
      {
         fm->ReadDat(&buf->type[0],TYPSIZE);
         fm->ReadDat(&buf->length,SPCSIZE);
         fm->ReadDat(&buf->orglength,SPCSIZE);
         if (buf->data) delete [] buf->data; buf->data = new char[buf->length];
         fm->ReadDat(buf->data,buf->length);

         if (buf->Compressed()) buf->Decompress();
         Text = AnsiString(buf->data);
         for (int i=0; i<Count; i++)
         {
            fm->ReadDat(&p,PTRSIZE);
            Objects[i] = (TObject*)p;
         }
      }
      catch(...)
      {
         MsgBoxHwnd(NULL,
            s("Failed to initialize database index: "+name+"\n\n")+
            s("QS may become unstable. Restarting QS may help. If problem\n")+
            s("persists, contact technical support: "+BUGREPORTADDRESS),
            s("File System Error"),MB_OK|MB_TASKMODAL);
      }
      delete buf;
   }
}
//---------------------------------------------------------------------------
void __fastcall TFMindex::ShowIndex()
{
   String idx;
   for (int i=0; i<Count; i++)
      idx += Strings[i]+"     "+String((int)Objects[i])+"\n";
   ShowMessage(idx);
}
//---------------------------------------------------------------------------
TFLspace __fastcall TFMindex::GetSize(AnsiString &key)
{
   assert(!key.IsEmpty());
   TFLoffset ofs = GetOffset(key);
   if (ofs == FLNIL) return 0;

   TFLspace spc=0;
   char type[TYPSIZE];
   fm->SeekTo(ofs);
   fm->ReadDat(&type[0],TYPSIZE);
   fm->ReadDat(&spc,SPCSIZE);
   return spc;
}
//---------------------------------------------------------------------------
char __fastcall TFMindex::GetType(AnsiString &key)
{
   assert(!key.IsEmpty());
   TFLoffset ofs = GetOffset(key);
   if (ofs == FLNIL) return -1;

   char type[TYPSIZE];
   fm->SeekTo(ofs);
   fm->ReadDat(&type[0],TYPSIZE);
   return type[0];
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFMindex::GetOffset(AnsiString &key)
{
   assert(!key.IsEmpty());
   int p = IndexOf(key);
   return p<0 ? FLNIL : (TFLoffset)Objects[p];
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFMindex::SetOffset(AnsiString &key, TFLoffset Offset)
{
   assert(Offset>0);
   if (key.IsEmpty()) return FLNIL;
   int p = IndexOf(key);
   if (p < 0)
   {
      Add(key);
      p = Count-1;
   }
   Objects[p] = (TObject*)Offset;
   return Offset;
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFMindex::PutOffset(AnsiString &key, TFLoffset Offset)
{
   assert(!key.IsEmpty() && Offset>0);
   TFLoffset ofs = SetOffset(key,Offset); Save();
   return ofs;
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFMindex::WriteIndex()
{
   assert(offset==-1 || offset>0);
   if (offset != FLNIL) // deallocate previous offset to index
      fm->Deallocate(offset);

   TDataBuf *buf = new TDataBuf(Text.c_str(),Text.Length()+1);
   if (buf)
   {
      buf->type[0] = ISINDEX;
      buf->type[1] = 0;
      buf->type[2] = 0;
      buf->type[3] = 0;
      try
      {
         if (UseCompression) buf->Compress();
         offset = fm->Allocate(TYPSIZE+(SPCSIZE*2)+buf->length+(Count*PTRSIZE));
         fm->SeekTo(offset);
         fm->WriteDat(&buf->type[0],TYPSIZE);
         fm->WriteDat(&buf->length,SPCSIZE);
         fm->WriteDat(&buf->orglength,SPCSIZE);
         fm->WriteDat(buf->data,buf->length);
         for (int i=0; i<Count; i++)
         {
            void *p = Objects[i];
            fm->WriteDat(&p,PTRSIZE);
         }
      }
      catch(...)
      {
         MsgBoxHwnd(NULL,
            s("Failed to write data index to disk. QS may become unstable.")+
            s("Restarting may help. If the condition persists, contact technical\n")+
            s("support: "+BUGREPORTADDRESS),
            s("File System Error"),
            MB_OK|MB_TASKMODAL
         );
      }
      delete buf;
   }
   return offset;
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFMindex::Save()
{
   TFLoffset ofs = WriteIndex();
   if (parent)
      parent->PutOffset(name,offset);
   else
   {
      fm->SeekTo(fm->start());
      fm->WriteDat(&offset,OFSSIZE);
   }
   return ofs;
}
//---------------------------------------------------------------------------
char* __fastcall TFMindex::GetBinary(AnsiString &key, TDataBuf *buf)
{
   if (!buf) return NULL;
   TFLoffset ofs = GetOffset(key);
   if (ofs == FLNIL) return NULL;

   try
   {
      fm->SeekTo(ofs);
      fm->ReadDat(&buf->type[0],TYPSIZE);
      fm->ReadDat(&buf->length,SPCSIZE);
      fm->ReadDat(&buf->orglength,SPCSIZE);
      if (buf->data) delete[] buf->data;

      buf->data = new char[buf->length+1]; buf->data[buf->length]=0;
      fm->ReadDat(buf->data,buf->length);
      if (buf->Compressed()) buf->Decompress();
   }
   catch(...)
   {
      MsgBoxHwnd(NULL,
         s("Failed to read data from disk. QS may become unstable. Restarting\n")+
         s("may help. If problem persists, contact technical support:\n")+
         s(BUGREPORTADDRESS),"File System Error",
         MB_OK|MB_TASKMODAL
      );
   }
   return buf->data;
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFMindex::PutBinary(AnsiString &key, TMemoryStream* buf, bool SaveIndex)
{
   // get key id or add if not already there
   int pos = IndexOf(key);
   if (pos < 0)
   {
      AddObject(key,(TObject*)FLNIL);
      pos = Count-1;
   }
   // get offset...deallocate, allocate...write space then data
   TFLoffset ofs = GetOffset(key);
   if (ofs != FLNIL)
      fm->Deallocate(ofs);

   if (!buf)
      Delete(IndexOf(key));
   else
   {
      void *p;
      char type[4] = { ISDATA,0,0,0 };
      int orglength = buf->Size;
      if (UseCompression && BufCompress(buf)==TOOL_OK)
         type[3] = COMPRESSED;

      if ((ofs = fm->Allocate(TYPSIZE+(SPCSIZE*2)+buf->Size+(Count*PTRSIZE))) != FLNIL)
      {
         try
         {
            long length = buf->Size;
            fm->SeekTo(ofs);
            fm->WriteDat(&type[0],TYPSIZE);
            fm->WriteDat(&length,SPCSIZE);
            fm->WriteDat(&orglength,SPCSIZE);
            fm->WriteDat(buf->Memory,buf->Size);
            // added to make index and data saves sameo sameo
            for (int i=0; i<Count; i++)
            {
               p = Objects[i];
               fm->WriteDat(&p,PTRSIZE);
            }
         }
         catch(...)
         {
            MsgBoxHwnd(NULL,
               s("Failed to save information to disk. You may be short of\n")+
               s("disk space. If condition persists, contact technical support:\n")+
               s(BUGREPORTADDRESS),"File System Error",
               MB_OK|MB_TASKMODAL
            );
         }
      }
      // assign new offset to index key and save
      Objects[pos] = (TObject*)ofs;
   }
   if (SaveIndex) Save();
   return ofs;
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFMindex::PutBinary(AnsiString &key, TDataBuf* buf, bool SaveIndex)
{
   assert(!key.IsEmpty() && buf>=NULL);
   // get key id or add if not already there
   int pos = IndexOf(key);
   if (pos < 0)
   {
      AddObject(key,(TObject*)FLNIL);
      pos = Count-1;
   }
   // get offset...deallocate, allocate...write space then data
   TFLoffset ofs = GetOffset(key);
   if (ofs != FLNIL)
      fm->Deallocate(ofs);

   if (!buf)
      Delete(IndexOf(key));
   else
   {
      void *p;
      buf->type[0] = ISDATA;
      buf->type[1] = 0;
      buf->type[2] = 0;
      buf->type[3] = 0;
      if (UseCompression) buf->Compress();
      if ((ofs = fm->Allocate(TYPSIZE+(SPCSIZE*2)+buf->length+(Count*PTRSIZE))) != FLNIL)
      {
         try
         {
            fm->SeekTo(ofs);
            fm->WriteDat(&buf->type[0],TYPSIZE);
            fm->WriteDat(&buf->length,SPCSIZE);
            fm->WriteDat(&buf->orglength,SPCSIZE);
            fm->WriteDat(buf->data,buf->length);
//view(s((int)ofs)+"\n"+s((int)buf->type)+"\n"+s((int)buf->length)+"\n"+s((int)buf->orglength));
         // added to make index and data saves sameo sameo
            for (int i=0; i<Count; i++)
            {
               p = Objects[i];
               fm->WriteDat(&p,PTRSIZE);
            }
         }
         catch(...)
         {
            MsgBoxHwnd(NULL,
               s("Failed to save information to disk. You may be short of\n")+
               s("disk space. If condition persists, contact technical support:\n")+
               s(BUGREPORTADDRESS),"File System Error",
               MB_OK|MB_TASKMODAL
            );
         }
      }
      // assign new offset to index key and save
      Objects[pos] = (TObject*)ofs;
   }
   if (SaveIndex) Save();
   return ofs;
}
//---------------------------------------------------------------------------
/*int __fastcall PutAppBinary(AnsiString &path, TMemoryStream *buf, AnsiString &datafile)
{
   String nodetext;
   int status = TOOL_OK;
   TFMindex *idx[16] = { 0 };
   TFileManager *fman = new TFileManager(datafile);
   idx[0] = new TFMindex(fman);

   int i=1; while ((nodetext = GetParam(i-1,path,PS.c_str())) != NULL)
   {
      if (GetParam(i,path,PS.c_str()).IsEmpty())
      {
         idx[i-1]->PutBinary(nodetext,buf);
         status = fman->status;
         break;
      }
      idx[i] = new TFMindex(fman,nodetext,idx[i-1]);
      i++;
   }

   for (i=i-1; i>0; i--)
      delete idx[i];
   delete fman;
   return status;
}*/
//---------------------------------------------------------------------------
int __fastcall PutAppBinary(AnsiString &path, TDataBuf *buf, AnsiString &datafile)
{
   assert(buf>=0);
   assert(!path.IsEmpty());
   String nodetext;
   int status = TOOL_OK;
   TFMindex *idx[16] = { 0 };
   TFileManager *fman = new TFileManager(datafile);
   idx[0] = new TFMindex(fman);

   int i=1; while ((nodetext = GetParam(i-1,path,PS.c_str())) != NULL)
   {
      if (GetParam(i,path,PS.c_str()).IsEmpty())
      {
         idx[i-1]->PutBinary(nodetext,buf);
         status = fman->status;
         break;
      }
      idx[i] = new TFMindex(fman,nodetext,idx[i-1]);
      i++;
   }

   for (i=i-1; i>0; i--)
      delete idx[i];
   delete fman;
   return status;
}
//---------------------------------------------------------------------------
int __fastcall PutAppBinaryData(AnsiString &path, char *data, int length, AnsiString &datafile)
{
   assert(!path.IsEmpty() && data>=0 && length>=0);
   TDataBuf *buffer = new TDataBuf(data,length);
   int status = PutAppBinary(path,buffer);
   delete buffer;
   return status;
}
//---------------------------------------------------------------------------
int __fastcall GetAppBinary(AnsiString &path, TDataBuf *buf, AnsiString &datafile)
{
   assert(buf>0);
   assert(!path.IsEmpty());
   int status=TOOL_OK;
   if (!FileExists(datafile)) return status;

   AnsiString nodetext;
   TFMindex *idx[16] = { 0 };
   TFileManager *fman = new TFileManager(datafile);
   idx[0] = new TFMindex(fman);
   int i=1; while ((nodetext = GetParam(i-1,path,PS.c_str())) != NULL)
   {
      if (GetParam(i,path,PS.c_str()).IsEmpty())
      {
         if (idx[i-1]->GetSize(nodetext)>0) idx[i-1]->GetBinary(nodetext,buf);
         status = fman->status;
         break;
      }
      idx[i] = new TFMindex(fman,nodetext,idx[i-1]);
      i++;
   }
   for (i=i-1; i>0; i--) delete idx[i];
   delete fman;
   return status;
}
//---------------------------------------------------------------------------
int __fastcall GetAppDataMainIndex(TStrings *items, AnsiString &datafile)
{
   assert(items>=0);
   TFileManager *fm = new TFileManager(datafile);
   TFMindex *idx = new TFMindex(fm);
   items->AddStrings(idx);
   int status = fm->status;
   delete idx;
   delete fm;
   return status;
}
//---------------------------------------------------------------------------
int __fastcall GetAppData(TStrings *items, AnsiString &path, AnsiString &datafile)
{
   assert(items>=0);
   assert(!path.IsEmpty());
   items->Clear();
   int status = TOOL_OK;
   TDataBuf *buf = new TDataBuf();
   if (buf != NULL)
   {
      status = GetAppBinary(path,buf,datafile);
      items->Text = s(buf->data);
      delete buf;
   }
   return status;
}
//---------------------------------------------------------------------------
int __fastcall PutAppData(AnsiString &path, TStrings *items, AnsiString &datafile)
{
   assert(items>=0);
   assert(!path.IsEmpty());
   TDataBuf *buf = NULL;
   if (items)
   {
      buf = new TDataBuf();
      if (items->Count) buf->Set(items->Text.c_str(),items->Text.Length());
   }
   int ret = PutAppBinary(path,buf,datafile);
   if (buf) delete buf;
   return ret;
}
//---------------------------------------------------------------------------
bool __fastcall AppBinaryExists(AnsiString &path, TDataBuf *data, AnsiString &datafile)
{
   assert(data>=0);
   assert(!path.IsEmpty());
   TDataBuf *tmp = new TDataBuf(); GetAppBinary(path,tmp,datafile);
   bool exists = tmp->length;
   if (data) data->Set(tmp->data,tmp->length);
   delete tmp;
   return exists;
}
//---------------------------------------------------------------------------
bool __fastcall AppDataExists(AnsiString &path, TStrings *data, AnsiString &datafile)
{
   assert(data>=0);
   assert(!path.IsEmpty());
   TStringList *tmp = new TStringList();
   GetAppData(tmp,path,datafile);
   bool exists = tmp->Count;
   if (data) data->Text = tmp->Text;
   delete tmp;
   return exists;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetAppIni(AnsiString &key, AnsiString &defvalue, AnsiString &datafile)
{
   assert(!key.IsEmpty());
   TStringList *ini = new TStringList();
   GetAppData(ini,AppIniValues,datafile);
   AnsiString val = ini->Values[key];
   delete ini;
   if (val.IsEmpty()) val = defvalue;
   return val;
}
//---------------------------------------------------------------------------
int __fastcall PutAppIni(AnsiString &key, AnsiString &Value, AnsiString &datafile)
{
   assert(!key.IsEmpty());
   TStringList *ini = new TStringList();
   GetAppData(ini,AppIniValues,datafile); ini->Values[key] = Value;
   int ret = PutAppData(AppIniValues,ini,datafile);
   delete ini;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall RenameAppIndex(AnsiString &Path, AnsiString &Newname, AnsiString &datafile)
{
   assert(!Path.IsEmpty());
   assert(!Newname.IsEmpty());
   String nodetext;
   int pos,status = TOOL_OK;
   TFMindex *idx[16] = { 0 };
   TFileManager *fman = new TFileManager(datafile);
   idx[0] = new TFMindex(fman);

   int i=1;
   while ((nodetext=GetParam(i-1,Path,PS.c_str()))!=NULL)
   {
      if (GetParam(i,Path,PS.c_str()).IsEmpty())
      {
         if ((pos=idx[i-1]->IndexOf(nodetext))>=0)
         {
            TObject *obj = idx[i-1]->Objects[pos];
            idx[i-1]->Strings[pos] = Newname;
            idx[i-1]->Objects[pos] = obj;
            idx[i-1]->Save();
         }
         status = fman->status;
         break;
      }
      idx[i] = new TFMindex(fman,nodetext,idx[i-1]);
      i++;
   }

   for (i=i-1; i>0; i--) delete idx[i];
   delete fman;
   return status;
}
//---------------------------------------------------------------------------
int __fastcall RenameAppItem(AnsiString &Path, AnsiString &Newname,
   AnsiString &datafile)
{
   assert(!Path.IsEmpty());
   assert(!Newname.IsEmpty());
   Path = Path.Trim(); //sm(Path);
   AnsiString nodetext;
   int pos,status=TOOL_OK;
   TFMindex *idx[16]={ 0 };
   TFileManager *fman = new TFileManager(datafile);
   idx[0] = new TFMindex(fman);
   int i=1; while ((nodetext=GetParam(i-1,Path,PS.c_str()))!=NULL)
   {
      if (GetParam(i,Path,PS.c_str()).IsEmpty())
      {
         pos = idx[i-1]->IndexOf(nodetext);
         if (pos>=0)
         {
            idx[i-1]->Strings[pos] = Newname;
            idx[i-1]->Save();
         }
         status = fman->status;
         break;
      }
      idx[i] = new TFMindex(fman,nodetext,idx[i-1]);
      i++;
   }

   for (i=i-1; i>0; i--) delete idx[i];
   delete fman;
   return status;
}
//---------------------------------------------------------------------------







